import csv

with open('data/ciy.csv') as f:
    rows = list(csv.reader(f))

print('HEX "tSTR" ID ParagraphData')
for i in range(365):
    start = int(rows[i][0])
    try:
        end = int(rows[i+1][0])
    except IndexError:
        end = 2865
    print("  0x{:02x} 0x{:02x}".format(start//256, start%256))

chapters = []
chapter = None
section = None
part = None
string_ids = dict()
next_id = 0
def _string_id(s):
    global next_id
    if s in string_ids:
        return string_ids[s]
    string_ids[s] = next_id
    next_id += 1
    return next_id-1
for i, row in enumerate(rows):
    if row[1] == '' and row[2] == '' and row[3] == '':
        continue
    if row[1] != '':
        chapter = _string_id(row[1])
    if row[2] != '':
        section = _string_id(row[2])
    if row[3] != '':
        part = _string_id(row[3])
    chapters.append((i, part, section, chapter))

print()
print('STRINGTABLE ID ChapterStrings ""')
for _, s in sorted(zip(string_ids.values(), string_ids.keys())):
    print('  "{}"'.format(s))

print()
print('HEX "tSTR" ID ChapterData')
for i, a, b, c in chapters:
    print("  0x{:02x} 0x{:02x} 0x{:02x} 0x{:02x} 0x{:02x}".format(
        i//256, i%256, a, b, c))
