#include <PalmOS.h>
#include "res.h"

Boolean MainFormHandleEvent(EventType *event);

static Boolean AppHandleEvent(EventType *event){
    FormType *form;

    switch(event->eType){
    case frmLoadEvent:
        form = FrmInitForm(event->data.frmLoad.formID);
        FrmSetActiveForm(form);
        switch(event->data.frmLoad.formID){
        case MainForm:
            FrmSetEventHandler(form, MainFormHandleEvent);
            break;
        }
        return true;
    default:
        return false;
    }
}

static void AppEventLoop(void)
{
    EventType event;
    do {
        EvtGetEvent(&event, evtWaitForever);
        if(!SysHandleEvent(&event))
            if(!AppHandleEvent(&event))
                FrmDispatchEvent(&event);
    } while (event.eType != appStopEvent);

}

static void AppStop(void){
    FrmCloseAllForms();
}

UInt32 PilotMain(UInt16 cmd, void *cmdPBP, UInt16 launchFlags) {
    if (sysAppLaunchCmdNormalLaunch == cmd) {
        FrmGotoForm(MainForm);
        AppEventLoop();
    }

    return 0;
}

UInt32 __attribute__((section(".vectors"))) __Startup__(void)
{
    SysAppInfoPtr appInfoP;
    void *prevGlobalsP;
    void *globalsP;
    UInt32 ret;
    
    SysAppStartup(&appInfoP, &prevGlobalsP, &globalsP);
    ret = PilotMain(appInfoP->cmd, appInfoP->cmdPBP, appInfoP->launchFlags);
    SysAppExit(appInfoP, prevGlobalsP, globalsP);
    
    return ret;
}
