#include "prefsmodal.h"
#include "res.h"
#include "persist.h"

static void _UpdateDayList(FormType *form){
    ListType *list;
    ControlType *control;
    UInt16 idx, numItems;
    Int16 sel;
    char *label;
    idx = FrmGetObjectIndex(form, MonthList);
    list = FrmGetObjectPtr(form, idx);
    switch(LstGetSelection(list)){
    case 1:
        numItems = 28;
        break;
    case 3:
    case 5:
    case 8:
    case 10:
        numItems = 30;
        break;
    default:
        numItems = 31;
        break;
    }
    idx = FrmGetObjectIndex(form, DayList);
    list = FrmGetObjectPtr(form, idx);
    sel = LstGetSelection(list);
    LstSetListChoices(list, list->itemsText, numItems);
    if((unsigned)sel >= numItems){
        sel = numItems - 1;
        LstSetSelection(list, sel);
        label = LstGetSelectionText(list, sel);
        idx = FrmGetObjectIndex(form, DayTrig);
        control = FrmGetObjectPtr(form, idx);
        CtlSetLabel(control, label);
    }
}

Boolean PrefsModalHandleEvent(EventType *event){
    FormType *form;
    switch(event->eType){
    case frmOpenEvent:
        form = FrmGetActiveForm();
        _UpdateDayList(form);
        FrmDrawForm(form);
        return true;
    case frmUpdateEvent:
        form = FrmGetActiveForm();
        FrmDrawForm(form);
        return true;
    case popSelectEvent:
        form = FrmGetActiveForm();
        switch(event->data.popSelect.listID){
        case MonthList:
            _UpdateDayList(form);
            return false;
        }
        return false;
    default:
        return false;
    }
}

void PrefsModalInit(FormType *form){
    struct myPrefs prefs;
    DateType date;
    ListType *list;
    ControlType *control;
    UInt16 idx;
    Int16 sel;
    char *label;

    MyPrefsGet(&prefs);
    date.year = 1;
    date.month = 1;
    date.day = 1;
    DateAdjust(&date, prefs.startDay);

    idx = FrmGetObjectIndex(form, MonthList);
    list = FrmGetObjectPtr(form, idx);
    sel = date.month - 1;
    LstSetSelection(list, sel);
    LstMakeItemVisible(list, sel);
    label = LstGetSelectionText(list, sel);
    idx = FrmGetObjectIndex(form, MonthTrig);
    control = FrmGetObjectPtr(form, idx);
    CtlSetLabel(control, label);

    idx = FrmGetObjectIndex(form, DayList);
    list = FrmGetObjectPtr(form, idx);
    sel = date.day - 1;
    LstSetSelection(list, sel);
    LstMakeItemVisible(list, sel);
    label = LstGetSelectionText(list, sel);
    idx = FrmGetObjectIndex(form, DayTrig);
    control = FrmGetObjectPtr(form, idx);
    CtlSetLabel(control, label);
}

void PrefsModalSave(FormType *form){
    struct myPrefs prefs;
    DateType date;
    ListType *list;
    UInt16 idx;

    MyPrefsGet(&prefs);
    date.year = 1;

    idx = FrmGetObjectIndex(form, MonthList);
    list = FrmGetObjectPtr(form, idx);
    date.month = 1 + LstGetSelection(list);

    idx = FrmGetObjectIndex(form, DayList);
    list = FrmGetObjectPtr(form, idx);
    date.day = 1 + LstGetSelection(list);

    prefs.startDay = DateToDays(date) - 366;
    MyPrefsSet(&prefs);
}
